GIT-BRANCH(1)

NAME
git-branch - List, create, or delete branches

SYNOPSIS

    git branch [--color | --no-color] [-r | -a]
            [-v [--abbrev=<length> | --no-abbrev]]
            [(--merged | --no-merged | --contains) [<commit>]]
    git branch [--track | --no-track] [-l] [-f] <branchname> [<start-point>]
    git branch (-m | -M) [<oldbranch>] <newbranch>
    git branch (-d | -D) [-r] <branchname>...

DESCRIPTION
With no arguments, existing branches are listed and the current branch will be highlighted with an asterisk. Option -r causes the remote-tracking branches to be listed, and option -a shows both. With --contains, shows only the branches that contain the named commit (in other words, the branches whose tip commits are descendants of the named commit). With --merged, only branches merged into the named commit (i.e. the branches whose tip commits are reachable from the named commit) will be listed. With --no-merged only branches not merged into the named commit will be listed. If the <commit> argument is missing it defaults to HEAD (i.e. the tip of the current branch). In the command's second form, a new branch named <branchname> will be created. It will start out with a head equal to the one given as <start-point>. If no <start-point> is given, the branch will be created with a head equal to that of the currently checked out branch. Note that this will create the new branch, but it will not switch the working tree to it; use "git checkout <newbranch>" to switch to the new branch. When a local branch is started off a remote branch, git sets up the branch so that git-pull will appropriately merge from the remote branch. This behavior may be changed via the global branch.autosetupmerge configuration flag. That setting can be overridden by using the --track and --no-track options. With a -m or -M option, <oldbranch> will be renamed to <newbranch>. If <oldbranch> had a corresponding reflog, it is renamed to match <newbranch>, and a reflog entry is created to remember the branch renaming. If <newbranch> exists, -M must be used to force the rename to happen. With a -d or -D option, <branchname> will be deleted. You may specify more than one branch for deletion. If the branch currently has a reflog then the reflog will also be deleted. Use -r together with -d to delete remote-tracking branches. Note, that it only makes sense to delete remote-tracking branches if they no longer exist in the remote repository or if git-fetch was configured not to fetch them again. See also the prune subcommand of git-remote(1) for a way to clean up all obsolete remote-tracking branches.

OPTIONS

-d
    Delete a branch. The branch must be fully merged in HEAD.

-D
    Delete a branch irrespective of its merged status.

-l
    Create the branch's reflog. This activates recording of all changes made to the branch ref, enabling use of date based sha1 expressions such as "<branchname>@{yesterday}".

-f
    Force the creation of a new branch even if it means deleting a branch that already exists with the same name.

-m
    Move/rename a branch and the corresponding reflog.

-M
    Move/rename a branch even if the new branch name already exists.

--color
    Color branches to highlight current, local, and remote branches.

--no-color
    Turn off branch colors, even when the configuration file gives the default to color output.

-r
    List or delete (if used with -d) the remote-tracking branches.

-a
    List both remote-tracking branches and local branches.

-v, --verbose
    Show sha1 and commit subject line for each head.

--abbrev=<length>
    Alter the sha1's minimum display length in the output listing. The default value is 7.

--no-abbrev
    Display the full sha1s in the output listing rather than abbreviating them.

--track
    When creating a new branch, set up the configuration so that git-pull will automatically retrieve data from the start point, which must be a branch. Use this if you always pull from the same upstream branch into the new branch, and if you do not want to use "git pull <repository> <refspec>" explicitly. This behavior is the default when the start point is a remote branch. Set the branch.autosetupmerge configuration variable to false if you want git-checkout and git-branch to always behave as if --no-track were given. Set it to always if you want this behavior when the start-point is either a local or remote branch.

--no-track
    Ignore the branch.autosetupmerge configuration variable.

--contains <commit>
    Only list branches which contain the specified commit.

--merged
    Only list branches which are fully contained by HEAD.

--no-merged
    Do not list branches which are fully contained by HEAD.

<branchname>
    The name of the branch to create or delete. The new branch name must pass all checks defined by git-check-ref-format(1). Some of these checks may restrict the characters allowed in a branch name.

<start-point>
    The new branch will be created with a HEAD equal to this. It may be given as a branch name, a commit-id, or a tag. If this option is omitted, the current branch is assumed.

<oldbranch>
    The name of an existing branch to rename.

<newbranch>
    The new name for an existing branch. The same restrictions as for <branchname> apply.

EXAMPLES

Start development from a known tag

        .ft C
        $ git clone git://git.kernel.org/pub/scm/.../linux-2.6 my2.6
        $ cd my2.6
        $ git branch my2.6.14 v2.6.14   (1)
        $ git checkout my2.6.14
        .ft

    1. This step and the next one could be combined into a single step with "checkout -b my2.6.14 v2.6.14".

Delete an unneeded branch

        .ft C
        $ git clone git://git.kernel.org/.../git.git my.git
        $ cd my.git
        $ git branch -d -r origin/todo origin/html origin/man   (1)
        $ git branch -D test                                    (2)
        .ft

    1. Delete the remote-tracking branches "todo", "html" and "man". The next fetch or pull will create them again unless you configure them not to. See git-fetch(1).
    2. Delete the "test" branch even if the "master" branch (or whichever branch is currently checked out) does not have all commits from the test branch.

NOTES
If you are creating a branch that you want to checkout immediately, it is easier to use the git checkout command with its -b option to create a branch and check it out with a single command. The options --contains, --merged and --no-merged serve three related but different purposes:

    • --contains <commit> is used to find all branches which will need special attention if <commit> were to be rebased or amended, since those branches contain the specified <commit>.

    • --merged is used to find all branches which can be safely deleted, since those branches are fully contained by HEAD.

    • --no-merged is used to find branches which are candidates for merging into HEAD, since those branches are not fully contained by HEAD.

AUTHOR
Written by Linus Torvalds <torvalds@osdl.org> and Junio C Hamano <gitster@pobox.com>

DOCUMENTATION
Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>.

GIT
Part of the git(1) suite